#ifndef KAPPWIDGETCOMMUNICATION_H
#define KAPPWIDGETCOMMUNICATION_H

#include <QObject>
#include <QDBusInterface>

namespace AppWidget {
class KAppWidgetManager;
class KAppWidgetConnect : public QObject
{
    Q_OBJECT

public:
    Q_CLASSINFO("D-Bus Interface", "org.ukui.appwidget")
    explicit KAppWidgetConnect(QObject *parent = nullptr);
    ~KAppWidgetConnect();

Q_SIGNALS:
    void usernameChanged();

signals:
    void clickedSignal(const QString &widgetname, const QDBusVariant &value);
    void defineEventSignal(const QString &eventname, const QString &widgetname, const QDBusVariant &value);
    void updatesignal();

public slots:
    void registerDbus(const QString &appname, const QString &username);
    QMap<QString, QVariant> getData();
    void onClickedEvent(const QString &widgetname, const QVariant &value);
    void onDefineEvent(const QString &eventname, const QString &widgetname, const QVariant &value);
    void updateAppWidget();

private:
    QString m_appname;
    QString m_username;
    int m_id;
    AppWidget::KAppWidgetManager * appwidgetinterface = nullptr;
};
} // namespace AppWidget
#endif // KAPPWIDGETCOMMUNICATION_H
