#include "kappwidgetprovider.h"
#include <kappwidgetcommon.h>

#include <QDBusConnection>
#include <QDBusError>
#include <QDebug>

namespace AppWidget
{
KAppWidgetProvider::KAppWidgetProvider(QString providername, QObject *parent): QObject(parent)
{
    if(providername.isEmpty()) {
        qWarning() << "providername isEmpty!";
        return;
    }
    QString servicename = KAppWidgetCommon::getProviderDbusObject(providername);
    QString objectpath = KAppWidgetCommon::getProviderDbusPath(providername);
    QString objectinterface = KAppWidgetCommon::getProviderDbusInterface(providername);
    QDBusConnection connection = QDBusConnection::sessionBus();
    if (connection.registerService(servicename)) {
        connection.registerObject(objectpath, objectinterface, this, QDBusConnection::ExportAllSlots);
        qDebug() << "Regist Dbus Service success";

    }else {
        qCritical() << "Register DBus Service Error:" << connection.lastError().message();
    }
}
void KAppWidgetProvider::appWidgetRecevie(const QString &eventname, const QString &widgetname, const QDBusVariant &value)
{
    Q_UNUSED(eventname);
    Q_UNUSED(widgetname);
    Q_UNUSED(value);
    qDebug() << "KAppWidgetProvider::appWidgetRecevie";
}
void KAppWidgetProvider::appWidgetUpdate()
{
    qDebug() << "KAppWidgetProvider::appWidgetUpdate";
}
void KAppWidgetProvider::appWidgetDisable()
{
    qDebug() << "KAppWidgetProvider::appWidgetDisable";
}
void KAppWidgetProvider::appWidgetDeleted()
{
    qDebug() << "KAppWidgetProvider::appWidgetDeleted";
}
void KAppWidgetProvider::appWidgetEnable()
{
    qDebug() << "KAppWidgetProvider::appWidgetEnable";
}
void KAppWidgetProvider::appWidgetClicked(const QString &widgetname, const QDBusVariant &value)
{
    Q_UNUSED(widgetname);
    Q_UNUSED(value);
    qDebug() << "KAppWidgetProvider::appWidgetClicked";
}
}// namespace AppWidget
