#ifndef APPWIDGETPROVIDERPROXY_H
#define APPWIDGETPROVIDERPROXY_H

#include <QDBusInterface>
#include <QVector>

namespace AppWidget {
class AppWidgetProxy;
class AppWidgetProviderProxy : public QDBusInterface
{
    Q_OBJECT
public:
    AppWidgetProviderProxy(int id, QString providerName);
    ~AppWidgetProviderProxy();


    void updateAppWidgetProviderProxyData(QMap<QString, QVariant> data);
    QMap<QString, QVariant> getAppWidgetProviderProxyData();

    AppWidgetProxy* createAppWidgetProxy(QString appwidgetname, QString username);
    bool destroyAppWidgetProxy(int id);
    int* getAllAppWidgetIds();

    void appWidgetRecevie(QString eventname, QString widgetname, QDBusVariant value);
    void appWidgetUpdate();
    void appWidgetDisable();
    void appWidgetDeleted();
    void appWidgetEnable();
    void appWidgetClicked(QString widgetname, QDBusVariant value);
    bool appWidgetProxyIsEmpty();
    AppWidgetProxy* getAppWidgetProxy(int id);
    int getAppWidgetProviderProxyIndex();
    QString getAppWidgetProviderProxyProviderName();

private:
    bool addAppWidgetProxy(int index, AppWidgetProxy* appwidgetproxy);
    bool deleteAppWidgetProxy(int index);
    int getUsableIndex();

private:
    QMap<QString, QVariant> m_data;
    QVector<AppWidgetProxy*> m_appwidgetproxy;
    int m_index;
    QString m_providername;
};
} // namespace AppWidget
#endif // APPWIDGETPROVIDERPROXY_H
