#include "appwidgetproxy.h"

#include "appwidgetproviderproxy.h"
#include "appwidgetcommon.h"
#include <kappwidgetcommon.h>

#include <QDBusPendingCall>
#include <QDebug>

namespace AppWidget {
AppWidgetProxy::AppWidgetProxy(int id, QString appwidgetname, QString appwidgetuser)
    :QDBusInterface(KAppWidgetCommon::getAppWidgetDbusObject(appwidgetuser,id),
                    KAppWidgetCommon::getAppWidgetDbusPath(appwidgetuser,id),
                    KAppWidgetCommon::getAppWidgetDbusInterface(appwidgetuser,id)),
     m_id(id),
     m_appwidgetname(appwidgetname),
     m_provider(nullptr)
{
    connect(this, &AppWidgetProxy::clickedSignal, this, &AppWidgetProxy::onClicked);
    connect(this, &AppWidgetProxy::defineEventSignal, this, &AppWidgetProxy::onDefineSignalType);
}

AppWidgetProxy::~AppWidgetProxy() 
{
}

void AppWidgetProxy::setProviderProxy(AppWidgetProviderProxy * providerproxy)
{
    m_provider = providerproxy;
}

int AppWidgetProxy::getAppWidgetProxyId()
{
    return m_id;
}

QString AppWidgetProxy::getAppWidgetProxyAppWidgetName()
{
    return m_appwidgetname;
}

void AppWidgetProxy::updateAppWidget()
{
    qDebug() << "dbus 调用提供端小插件代理"  << m_id;
    this->asyncCall("updateAppWidget");
}

void AppWidgetProxy::onClicked(QString widgetname, QDBusVariant value)
{
    m_provider->appWidgetClicked(widgetname, value);
}

void AppWidgetProxy::onDefineSignalType(QString eventname, QString widgetname, QDBusVariant value)
{
    m_provider->appWidgetRecevie(eventname, widgetname, value);
}
} // namespace AppWidget
