#ifndef APPWIDGETPROXY_H
#define APPWIDGETPROXY_H

#include <QDBusInterface>

namespace AppWidget {
class AppWidgetProviderProxy;
class AppWidgetProxy : public QDBusInterface
{
    Q_OBJECT
public:
    AppWidgetProxy(int id, QString appwidgetname, QString appwidgetuser);
    ~AppWidgetProxy();


    void updateAppWidget();
    void updateAppWidgetOptions(QVariant key, QVariant value);
    bool updateAppWidgetSize(QSize);
    int  getAppWidgetProxyId();
    QString getAppWidgetProxyAppWidgetName();
    void setProviderProxy(AppWidgetProviderProxy * providerproxy);

public slots:
    void onClicked(QString widgetname, QDBusVariant value);
    void onDefineSignalType(QString eventname, QString widgetname, QDBusVariant value);

private:
    int m_id ;
    QString m_appwidgetname;
    AppWidgetProviderProxy* m_provider;


signals:
    void clickedSignal(QString widgetname, QDBusVariant value);
    void defineEventSignal(QString eventname, QString widgetname, QDBusVariant value);

};
} // namespace AppWidget
#endif // APPWIDGETPROXY_H
