#ifndef MAPPINGMANAGER_H
#define MAPPINGMANAGER_H

#include <QString>
#include <QVector>
#include <QObject>

namespace AppWidget {
class AppWidgetProviderProxy;
class AppWidgetProxy;
class MappingManager:public QObject
{
    Q_OBJECT
public:
    MappingManager(QObject *parent = nullptr);
    ~MappingManager();

    AppWidgetProviderProxy* findProviderProxyByProviderName(const QString providername);
    AppWidgetProviderProxy* findProviderProxyByAppWidgetId(int id);
    AppWidgetProxy* findAppWidgetProxyByAppWidgetId(int id);

    AppWidgetProviderProxy* createProviderProxy(QString providername);
    void destroyProviderProxy(AppWidgetProviderProxy* providerproxy);

private:
    int getUsableIndex();
    void addProviderProxy(int index, AppWidgetProviderProxy* providerproxy);
    void deleteProviderProxy(int index);

private:
    QVector<AppWidgetProviderProxy*> m_providerproxy;
};
} // namespace AppWidget

#endif // MAPPINGMANAGER_H
