#include "clockprovider.h"
#include <kappwidgetmanager.h>

#include <QSettings>
#include <QDir>
#include <QProcess>
#include <QCoreApplication>
#include <QDebug>

ClockProvider::ClockProvider(QString providername ,QObject *parent)
    : KAppWidgetProvider(providername , parent)
{
    if(manager) {
        manager = new AppWidget::KAppWidgetManager(this);
    }
}
void ClockProvider::appWidgetRecevie(const QString &eventname, const QString &widgetname, const QDBusVariant &value)
{ 
    Q_UNUSED(eventname);
    Q_UNUSED(widgetname);
    Q_UNUSED(value);
    qDebug() << "TestProvider::appWidgetRecevie";
}
void ClockProvider::appWidgetUpdate()
{
    qDebug() << "TestProvider::appWidgetUpdate";
    QStringList message;
    QString path = QDir::homePath()+"/.config/appwidgetclock/config.ini";
    setting = new QSettings(path,QSettings::IniFormat);
    dateTime = QDateTime::currentDateTime();

    setting->beginGroup("AlarmClock");
    QStringList ll = setting->allKeys();
    for (int var = 0; var < ll.count(); var++) {
        message << ll.at(var);
    }
    setting->endGroup();
    setting->sync();
    //需要将传递的消息用QDBusVariant封装，并用QVariant封装传递出去
    QVariantMap m;
    m.insert("date" , dateTime.toString("yyyy-MM-dd"));
    m.insert("AlarmClock" , message);
    qDebug() << "QVariantMap:" << m;
    if(manager) {
        manager->updateAppWidget("clock", m);
        qDebug() <<"更新";
    }

    if(setting) {
        delete setting;
    }
}
void ClockProvider::appWidgetDisable()
{
    qDebug() << "TestProvider::appWidgetDisable";
    if(manager) {
        delete manager;
    }
    qApp->exit();
}
void ClockProvider::appWidgetDeleted()
{
    qDebug() << "TestProvider::appWidgetDeleted";
}
void ClockProvider::appWidgetEnable()
{
    qDebug() << "TestProvider::appWidgetEnable";
    if(!manager) {
        manager = new AppWidget::KAppWidgetManager(this);
    }
}
void ClockProvider::appWidgetClicked(const QString &widgetname, const QDBusVariant &value)
{
    qDebug() << "TestProvider::appWidgetClicked";
    Q_UNUSED(widgetname);
    Q_UNUSED(value);
    QProcess::startDetached("appwidgetprovider-clock-demo");

}
