import QtQuick 2.6
import QtQuick.Window 2.2
import QtQuick.Controls 2.5
import QtQuick.Layouts 1.3
import QtGraphicalEffects 1.0
import org.ukui.appwidget 1.0

AppWidget  {
    width: 640
    height: 100
    visible: true
    id:window
    appname: "search"

    Rectangle
    {
        id:searchBar
        anchors.centerIn: parent
        width:400
        height: 35
        border.color: "#fc5531"
        border.width: 1
        radius: searchBar.height / 2

        TextInput {
            id:searchtext
            anchors.leftMargin: 20
            anchors.right: btn.left
            anchors.left: parent.left
            font.pointSize: 12
            color: "Black"
            y:8
            maximumLength: 30
            focus: true


            onAccepted: {
                console.log("你输入的值为:"+text);
                window.qmlclickedsignal("search",text);
            }

            MouseArea  {
                anchors.fill: parent
                hoverEnabled: true

                onEntered: {
                    searchBar.border.color = "#fc1944"
                    console.log("on entered");
                }

                onExited: {
                    searchBar.border.color = "#fc5531"
                    console.log("on exited");
                }
                onClicked:
                {
                    console.log("text onClicked");
                }

            }
        }

        // right button #fc1944
        Rectangle {
            id:btn
            width: 80
            height: searchBar.height
            anchors.right: parent.right
            anchors.top: parent.top
            color: "#fc5531"
            layer.enabled: true
            layer.effect: OpacityMask{
                maskSource: Rectangle{
                    width: 80
                    height: btn.height
                    radius: btn.height / 2
                    //左侧
                    Rectangle{
                        width: 20
                        height: btn.height
                    }
                }
            }

            Image {
                id: image_search
                width: 20
                height:20
                x:10
                anchors.verticalCenter: parent.verticalCenter
                source: "file:///usr/share/appwidgetdemo/search/ukui-search.svg"
            }

            Text {
                id: searchTxt
                color: "White"
                text: qsTr("搜索")
                anchors.verticalCenter: parent.verticalCenter
                anchors.left:image_search.right
                anchors.leftMargin: 1
                font.pointSize: 12
                font.bold: true
            }


            MouseArea  {
                anchors.fill: parent
                hoverEnabled: true

                onEntered: {
                    btn.color = "#fc1944"

                    console.log("button entered");
                }

                onExited: {
                    btn.color = "#fc5531"
                    console.log("button exited");
                }
                onClicked:
                {
                    console.log("搜索 :",searchtext.text);
                    window.qmlclickedsignal("search", searchtext.text);
                }
            }
        }

    }
}


