#ifndef APPWIDGETMODEL_H
#define APPWIDGETMODEL_H

#include <kappwidgetmanager.h>
#include <QAbstractListModel>

struct LIST_APPWIDGET_ITEM_INFO {
    QString appItemQml;
    QString appItemName;
};

class AppWidgetModel : public QAbstractListModel
{
    Q_OBJECT

public:
    explicit AppWidgetModel(QObject *parent = nullptr);

    enum LIST_APPWIDGET_ITEM_ROLE {
        appWidgetItemQmlRole = Qt::UserRole + 1,
        appWidgetItemNameRole,
    };
    // Header:
    QVariant headerData(int section, Qt::Orientation orientation, int role = Qt::DisplayRole) const override;

    // Basic functionality:
    int rowCount(const QModelIndex &parent = QModelIndex()) const override;
    QVariant data(const QModelIndex &index, int role = Qt::DisplayRole) const override;

    // Add data:
    Q_INVOKABLE void insert(QString appItemQml, QString appItemName) ;
    int count() const;
    QHash<int, QByteArray> roleNames() const override;
private:
    QList<LIST_APPWIDGET_ITEM_INFO> m_date;
    QHash<int, QByteArray> m_roleName;
    AppWidget::KAppWidgetManager * appwidgetinterface = nullptr;
};

#endif // APPWIDGETMODEL_H
