#include <QApplication>
#include <QQmlApplicationEngine>
#include <QQmlContext>
#include "listmodel.h"
#include "appwidgetmodel.h"
#include <QQuickStyle>

int main(int argc, char *argv[])
{
    QApplication app(argc, argv);

    QQmlApplicationEngine engine;

    ListModel listModel;
    AppWidgetModel appwidgetModel;
    engine.rootContext()->setContextProperty("AppWidgetModel", &appwidgetModel);
    engine.rootContext()->setContextProperty("KListModel", &listModel);

    QQuickStyle::setStyle("org.ukui.style");

    const QUrl url(QStringLiteral("qrc:/main.qml"));
    QObject::connect(&engine, &QQmlApplicationEngine::objectCreated,
                     &app, [url](QObject *obj, const QUrl &objUrl) {
        if (!obj && url == objUrl)
            QCoreApplication::exit(-1);
    }, Qt::QueuedConnection);
    engine.load(url);

    return app.exec();
}
